xui = xui or {}

xui.GestureManager = xui.GestureManager or {
    CLICK = "click_action",
    TOUCH_MOVE = "touchMove_action",
    TOUCH_PINCH = "touchPinch_action",
    DOUBLE_TOUCH_MOVE = "doubleTouchMove_action",
    TOUCH_ROTATE_EVENT = "touchRotateEvent_action",
}
function xui.GestureManager._onClick (arg)
    local actions = xui.GestureManager[xui.GestureManager.CLICK]
    if actions then
        for i = 1, #actions do
            actions[i].cb(actions[i].obj, arg)
        end    
    end
end

function xui.GestureManager:On(type, callback, selfObj)

    if not xui._glister then
        xui._glister = xe.GestureEventListenerV1:Create()
        xui._glister:RegisterHandler(function(sender, arg)
            xui.GestureManager._onClick(arg)
        end, xe.Handler.EVENT_GESTURE_CLICK)
        _G_Director:GetEventDispatcher():AddEventListener(xui._glister, nil);    
    end
    
    if self[type] == nil then
        self[type] = {}
    end
    table.insert(self[type], { cb = callback, obj = selfObj })
end

function xui.GestureManager:Off(actionType, callbackFunc)
    if type(actionType) == 'table' or type(actionType) == 'userdata' then
        self:_OffAll(actionType)
        return
    end

    local events = self[actionType];
    if events == nil then
        return
    end

    for i = #events, 1, -1 do
        if events[i].cb == callbackFunc then
            table.removevalue(events, events[i])
            break
        end
    end

end

function xui.GestureManager:_OffAll(target)
    local events = { self[self.CLICK],
                     self[self.TOUCH_MOVE],
                     self[self.TOUCH_PINCH],
                     self[self.DOUBLE_TOUCH_MOVE],
                     self[self.TOUCH_ROTATE_EVENT] };

    for i = 1, #events do
        if events[i] == nil then
            return
        end

        local gestureEvents = events[i]

        for i = #gestureEvents, 1, -1 do
            if gestureEvents[i].obj == target then
                table.remove(gestureEvents, i)
            end
        end
    end

end

function xui.GestureManager:Clear()
    self[self.CLICK] = nil;
    self[self.TOUCH_MOVE] = nil;
    self[self.TOUCH_PINCH] = nil;
    self[self.DOUBLE_TOUCH_MOVE] = nil;
    self[self.TOUCH_ROTATE_EVENT] = nil;
end

g_pIXUIManager = _G_UIManager
function IXUIManager:GetGlobal()
    return _G_UIManager
end

local __XUIVirtualListView_SetVirtualListDelegate__ = XUIVirtualListView.SetVirtualListDelegate
function XUIVirtualListView:SetVirtualListDelegate(delegate)
    self._m_delegate = delegate
    __XUIVirtualListView_SetVirtualListDelegate__(self, delegate)
end

local __XUIDynamicListView_SetDynamicListDelegate__ = XUIDynamicListView.SetDynamicListDelegate
function XUIDynamicListView:SetDynamicListDelegate(delegate)
    self._m_delegate = delegate
    __XUIDynamicListView_SetDynamicListDelegate__(self, delegate)
end

local __XUIEditBox_SetDelegate__ = XUIEditBox.SetDelegate
function XUIEditBox:SetDelegate(delegate)
    self._m_delegate = delegate
    __XUIEditBox_SetDelegate__(self, delegate)
end
